# Class BaseMessageRequest

Namespace
  AnthropicClient.Models

Assembly
  AnthropicClient.dll

Represents a message request.

    public abstract class BaseMessageRequest

Inheritance
  object
  BaseMessageRequest

Derived
  MessageRequest
  StreamMessageRequest

Inherited Members
  object.Equals(object)
  object.Equals(object, object)
  object.GetHashCode()
  object.GetType()
  object.MemberwiseClone()
  object.ReferenceEquals(object, object)
  object.ToString()

## Constructors

### BaseMessageRequest(string, List<Message>, int, string?, Dictionary<string, object>?, decimal, int?, decimal?, ToolChoice?, List<Tool>?, bool, List<string>?)

Initializes a new instance of the BaseMessageRequest class.

    protected BaseMessageRequest(string model, List<Message> messages, int maxTokens = 1024, string? system = null, Dictionary<string, object>? metadata = null, decimal temperature = 0.0, int? topK = null, decimal? topP = null, ToolChoice? toolChoice = null, List<Tool>? tools = null, bool stream = false, List<string>? stopSequences = null)

#### Parameters

`model` string

  The model ID to use for the request.

`messages` List<Message>

  The messages to send to the model.

`maxTokens` int

  The maximum number of tokens to generate.

`system` string

  The system ID to use for the request.

`metadata` Dictionary<string, object>

  The metadata to include with the request.

`temperature` decimal

  The temperature to use for the request.

`topK` int?

  The top-K value to use for the request.

`topP` decimal?

  The top-P value to use for the request.

`toolChoice` ToolChoice

  The tool choice mode to use for the request.

`tools` List<Tool>

  The tools to use for the request.

`stream` bool

  A value indicating whether the message should be streamed.

`stopSequences` List<string>

  The prompt stop sequences.

#### Exceptions

ArgumentException

  Thrown when the model ID is invalid.

ArgumentNullException

  Thrown when the model or messages is null.

ArgumentException

  Thrown when the messages contain no messages.

ArgumentException

  Thrown when the max tokens is less than one.

ArgumentException

  Thrown when the temperature is less than zero or greater than one.

## Properties

### MaxTokens

Gets the maximum number of tokens to generate.

    [JsonPropertyName("max_tokens")]
    public int MaxTokens { get; init; }

#### Property Value

int

### Messages

Gets the messages to send to the model.

    public List<Message> Messages { get; init; }

#### Property Value

List<Message>

### Metadata

Gets the metadata to include with the request.

    public Dictionary<string, object>? Metadata { get; init; }

#### Property Value

Dictionary<string, object>

### Model

Gets the model ID to use for the request.

    public string Model { get; init; }

#### Property Value

string

### StopSequences

Gets the prompt stop sequences.

    [JsonPropertyName("stop_sequences")]
    public List<string> StopSequences { get; init; }

#### Property Value

List<string>

### Stream

Gets a value indicating whether the message should be streamed.

    public bool Stream { get; init; }

#### Property Value

bool

### System

Gets the system prompt to use for the request.

    public string? System { get; init; }

#### Property Value

string

### Temperature

Gets the temperature to use for the request.

    public decimal Temperature { get; init; }

#### Property Value

decimal

### ToolChoice

Gets the tool choice mode to use for the request.

    [JsonPropertyName("tool_choice")]
    public ToolChoice? ToolChoice { get; init; }

#### Property Value

ToolChoice

### Tools

Gets the tools to use for the request.

    public List<Tool>? Tools { get; init; }

#### Property Value

List<Tool>

### TopK

Gets the top-K value to use for the request.

    public int? TopK { get; init; }

#### Property Value

int?

### TopP

Gets the top-P value to use for the request.

    public decimal? TopP { get; init; }

#### Property Value

decimal?